//
// $Source: /mnt/cvs/rep/CW/HID08/Sources/main.c,v $
// $Id: main.c,v 1.1 2008/04/27 13:44:12 noritan Exp $
//
// Simple HID Mouse Demo Code

#include <hidef.h> /* for EnableInterrupts macro */
#include "derivative.h" /* include peripheral declarations */
#include "usb_lowlevel.h"
#include "lcd.h"

//--------------------------------------------------------------
//  Time constants
//--------------------------------------------------------------
#define   _CPU_CLOCK_   (12000000UL)
#define   _BUS_CLOCK_   (6000000UL)
#define   PERIOD_PS     (1)
#define   PERIOD_1m00   ((_BUS_CLOCK_ / PERIOD_PS / 1000) - 1)

volatile byte ep0OutBuffer[EP0OUT_SIZE];

void main() {
	CONFIG  = 0x21;	  // USB Reset Disable, COP Disable
	
  T1MOD = PERIOD_1m00;  // Set modulo period
  T1SC =  0b00110000;
  //        |||||+++--- PS=000      prescaler x1
  //        ||||+------ Reserved
  //        |||+------- TRST=1      Reset counter
  //        ||+-------- TSTOP=1     Disable counter
  //        |+--------- TOIE=0      Disable OVF interrupt
  //        +---------- Not affected
  T1SC_TSTOP = 0;               // Enable timer counter

	lcd_init();                   // initialize LCD

	initUsb();		                // init USB
	
	PTD     = 0x3C;               // init LED to turn OFF
	DDRD    = 0x3C;               // init LED

  PTC     = 0x00;               // Init LCD_E	
	DDRC    = 0x01;               // Init LCD_E
    
	EnableInterrupts

  for (;;) {
    dispatch();
    if (usbState == US_CONFIGURED) {
      if (!UCR2_RX2E) {
        UCR2_RX2E = 1;
      }
      if (!UCR2_TX2E) {
        UCR2_T2SEQ = 0;
        UCR2_TP2SIZ = 8;
        UCR2_TX2E = 1;
      }
    }
    if (UIR1_RXD2F) {
      UCR2_RX2E = 0;            // NAKing
      UIR2_RXD2FR = 1;          // Acknowledge
      lcd_putc(UE2D0);          // Show in LCD
      UCR2_RX2E = 1;            // Ready for receive
    }
    if (UIR1_TXD2F) {
      UCR2_TX2E = 0;            // NAKing
      UIR2_TXD2FR = 1;          // Acknowledge
      UE2D0 = UE2D0;            // Echo back
      UCR2_T2SEQ = ~UCR2_T2SEQ; // Adjust sequence
      UCR2_TX2E = 1;            // Ready for transmit
    }
	}
}

//============================================================================
